#define _REENTRANT
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <string.h>

#include "callbacks.h"
#include "interface.h"
#include "interface2.h"
#include "game.h"
#include "support.h"

#define FILE_ACTION_NONE 0
#define FILE_ACTION_SAVE 1
#define FILE_ACTION_LOAD 2

static int file_action = 0;

gint replay_timer;

void
on_exit_clicked			       (GtkObject	*object,
					gpointer	user_data)
{
	if (is_game_now) {
		End_Game();
	}
	gtk_main_quit();
}

void
on_btn_new_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	if (user_data == (gpointer) 1) {
		start_win = create_start_win();
	
		/* Nastaveni hodnot dialogu */	

		/* Hrac X */
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(x_local), game_cfg.x.is_local ? TRUE : FALSE);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(x_net), game_cfg.x.is_local ? FALSE : TRUE);
		gtk_entry_set_text(GTK_ENTRY(x_name), (gchar *) game_cfg.x.name);
		gtk_entry_set_text(GTK_ENTRY(x_cmd), (gchar *) game_cfg.x.cmd);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(x_rbt), game_cfg.x.is_rbt ? TRUE : FALSE);

		gtk_entry_set_text(GTK_ENTRY(x_adr), (gchar *) game_cfg.x.adr);
		gtk_spin_button_set_value(GTK_SPIN_BUTTON(x_port), game_cfg.x.port);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(x_connect), game_cfg.x.is_server ? FALSE : TRUE);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(x_wait), game_cfg.x.is_server ? TRUE : FALSE);

		/* Hrac O */
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(o_local), game_cfg.o.is_local ? TRUE : FALSE);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(o_net), game_cfg.o.is_local ? FALSE : TRUE);
		gtk_entry_set_text(GTK_ENTRY(o_name), (gchar *) game_cfg.o.name);
		gtk_entry_set_text(GTK_ENTRY(o_cmd), (gchar *) game_cfg.o.cmd);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(o_rbt), game_cfg.o.is_rbt ? TRUE : FALSE);

		gtk_entry_set_text(GTK_ENTRY(o_adr), (gchar *) game_cfg.o.adr);
		gtk_spin_button_set_value(GTK_SPIN_BUTTON(o_port), game_cfg.o.port);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(o_connect), game_cfg.o.is_server ? FALSE : TRUE);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(o_wait), game_cfg.o.is_server ? TRUE : FALSE);

		/* Konfigurace Site */
		gtk_entry_set_text(GTK_ENTRY(net_adr), (gchar *) game_cfg.adr);
		gtk_spin_button_set_value(GTK_SPIN_BUTTON(net_port), game_cfg.port);
		
		/* Nastaveni hry */
		gtk_spin_button_set_value(GTK_SPIN_BUTTON(row), game_cfg.row);
		gtk_spin_button_set_value(GTK_SPIN_BUTTON(col), game_cfg.col);
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(begin_combo)->entry),
				game_cfg.begin == PLAYER_X ? "X" : "O");
		
		gtk_widget_show(start_win);
	} else {
		on_start_clicked(NULL, (gpointer) 2);
	}
}


void
on_btn_end_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
 
	is_game_now = 0;
	End_Game();
	refresh_btns();
}


void
on_btn_save_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	file_action = FILE_ACTION_SAVE;
	file = create_file();
	gtk_widget_show(file);
}


void
on_btn_load_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	file_action = FILE_ACTION_LOAD;
	file = create_file();
	gtk_widget_show(file);
	refresh_btns();
}


void
on_btn_about_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_btn_step_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	if (user_data == (gpointer) 1) {
		Next_Turn();
	} else {
		Prev_Turn();
	}
}


void
on_btn_play_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	if (user_data == (gpointer) 1) {
		Message("Replay...");
		replay_timer = gtk_timeout_add(700, Replay_Timer, NULL);
	} else {
		Message("");
		gtk_timeout_remove(replay_timer);
	}
}


void
on_turn_list_select_child              (GtkList         *list,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_x_toggled                           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	Start_Win_Net_Update();
}


void
on_x_rbt_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	gtk_widget_set_sensitive(x_cmd, GTK_TOGGLE_BUTTON(x_rbt)->active);
	gtk_widget_set_sensitive(x_cmd_label, GTK_TOGGLE_BUTTON(x_rbt)->active);
}


void
on_x_connect_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}


void
on_o_toggled                           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	Start_Win_Net_Update();
}


void
on_o_rbt_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	gtk_widget_set_sensitive(o_cmd, GTK_TOGGLE_BUTTON(o_rbt)->active);
	gtk_widget_set_sensitive(o_cmd_label, GTK_TOGGLE_BUTTON(o_rbt)->active);
}


void
on_o_connect_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}


void
on_firstturn_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}


void
on_btn_game_clicked			(GtkButton	*button,
					gpointer	 user_data)
{
	if (is_game_now) {
		Play_Area_Turn((int) user_data);
	}
}


void
on_start_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
	if (user_data >= (gpointer) 1) {
		Destroy_Play_Area();
	}
	
	if (user_data == (gpointer) 1) {
		/* Hrac X  */
		game_cfg.x.is_local = GTK_TOGGLE_BUTTON(x_local)->active ? 1 : 0;
		strcpy(game_cfg.x.name, gtk_entry_get_text(GTK_ENTRY(x_name)));
		strcpy(game_cfg.x.cmd, gtk_entry_get_text(GTK_ENTRY(x_cmd)));
		game_cfg.x.is_rbt = GTK_TOGGLE_BUTTON(x_rbt)->active ? 1 : 0;
		
		strcpy(game_cfg.x.adr, gtk_entry_get_text(GTK_ENTRY(x_adr)));
		game_cfg.x.port = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(x_port));
		game_cfg.x.is_server = GTK_TOGGLE_BUTTON(x_wait)->active;

		/* Hrac O */
		game_cfg.o.is_local = GTK_TOGGLE_BUTTON(o_local)->active ? 1 : 0;
		strcpy(game_cfg.o.name, gtk_entry_get_text(GTK_ENTRY(o_name)));
		strcpy(game_cfg.o.cmd, gtk_entry_get_text(GTK_ENTRY(o_cmd)));
		game_cfg.o.is_rbt = GTK_TOGGLE_BUTTON(o_rbt)->active ? 1 : 0;

		strcpy(game_cfg.o.adr, gtk_entry_get_text(GTK_ENTRY(o_adr)));
		game_cfg.o.port = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(o_port));
		game_cfg.o.is_server = GTK_TOGGLE_BUTTON(o_wait)->active;

		/* Konfigurace Site */
		
		strcpy(game_cfg.adr, gtk_entry_get_text(GTK_ENTRY(net_adr)));
		game_cfg.port = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(net_port));

		/* Nastaveni Hry */
		game_cfg.row = game_cfg.col = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(row));
		game_cfg.begin = PLAYER_SYMBOL(PLAYER_X) == (gtk_entry_get_text(GTK_ENTRY(begin)))[0] ?
			PLAYER_X : PLAYER_O;
	}
	
	if (start_win) {
		gtk_widget_destroy(start_win);
		start_win = NULL;
	}
	
	if (user_data >= (gpointer) 1) {
		is_game_now = 1;
		
		Create_Play_Area();
		Start_Game();
		play_timer = gtk_timeout_add(10, Play_Timer, NULL);
		refresh_btns();
	}
}


void
on_file_btn_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	/* Provedeni akce */
	if (user_data != (int) 0) {
		switch(file_action) {
			case FILE_ACTION_LOAD:
				Load_Game(gtk_file_selection_get_filename(GTK_FILE_SELECTION(file)));
				break;
			
			case FILE_ACTION_SAVE:
				Save_Game(gtk_file_selection_get_filename(GTK_FILE_SELECTION(file)));
				break;
		}
	}

	/* Likvidace dialogu */
	gtk_widget_destroy(file);
	file_action = FILE_ACTION_NONE;
}


gint Update_Highlight (gpointer user_data) {
 int i;
	
	for (i = 0; i < highlight_pos ; i++) {
		if (highlight_state) {
			gtk_label_set_text(GTK_LABEL(btn_game_label[highlight_turn[i]]), " ");
		} else {
			gtk_label_set_text(GTK_LABEL(btn_game_label[highlight_turn[i]]),
					play_area[highlight_turn[i]] == PLAYER_X ? 
					"X" : "O");
		}
	}
	highlight_state = ! highlight_state;
	return TRUE;
}


gint Play_Timer (gpointer user_data) {
	if (Turn() == -1)
		return 0;
	return 1;
}

gint Replay_Timer (gpointer user_data) {
	return Next_Turn();
}

