/*
 * 	game.h
 * 	Veci tykajici se vlastni hry
 *
 * 	Josef Kufner <jkufner@seznam.cz>
 */

/* Identifikace hracu */
#define PLAYER_NONE		0	/* Zadny hrac */
#define PLAYER_X		1	/* Hrac X */
#define PLAYER_O		2	/* Hrac O */

#define PLAYER_SYMBOL(x)	((x) == PLAYER_NONE ? ' ' : ((x) == PLAYER_X ? 'X' : 'O'))

/* Parametr fn Turn_Hist_Get_Item */
#define TH_START		0
#define TH_NEXT			1

/* Probiha hra ? */
extern int is_game_now;

/* Sub struktura struktury 'game_cfg_struct' */
struct game_cfg_player_struct {
	int  is_local;		/* Je hrac mistni(1) nebo vzdaleny(0) */
		/* Pokud je hrac mistni: */
	char name[256];		/* Hracovo jmeno */
	char cmd[256];		/* Prikaz ke spusteni robota (pokud is_rbt == 1) */
	int  is_rbt;		/* Bude hrat za hrace robot ? */
		/* Pokud je hrac vzdaleny: */
	char adr[512];		/* IP Adresa hrace */
	long int  port;		/* Port hrace */
	int  is_server;		/* Je hrac server (ten druhy se knemu pripoji)
				 * nebo neni (pripoji se k tomu druhemu) */
		/* Pomocne polozky - netykaji se konfigurace */
	long int rbt_pid;
	char rbt_f_nam[1024];
	FILE *rbt_f_out, *rbt_f_in;
	int sock_fd;		/* Deskriptor souboru -- socketu (inet) */
};

typedef struct game_cfg_struct {
		/* Hraci */
	struct game_cfg_player_struct x, o;
	int winner;
		/* Sitove informace */
	char adr[512];		/* IP Adresa pocitace na kterem toto bezi */
	long int  port;		/* port */
	char netgate_cmd[256];	/* prikaz ke spusteni netgate */
		/* Nastaveni hry */
	int  row, col;		/* Rozmery hraciho pole */
	int  is_square;		/* Je pole ctvercove ? */
	int  begin;		/* Kdo zacne (jen pokud gen_first == 1)  */
	int  gen_first;		/* Ma se vygenerovat prvni tah 'begin' */
} GAME_CFG;

/* Struktura udrzujici informace o hracich, hre a siti */
extern GAME_CFG game_cfg;

extern int *play_area;

/* Obsluha hry */
void Start_Game (void);
void End_Game (void);
int Turn (void);
int Check_Play_Area(int player);

/* Odeslani tahu deskou */
void Play_Area_Turn (int turn);


/* Ukladani a nacitani hry ze souboru */
int Load_Game (const char *file_name);
int Save_Game (const char *file_name);

/* Obsluha seznamu historie tahu */
int Turn_Hist_Add_Item(int player, int turn);
int Turn_Hist_Get_Item (const int where, int *player, int *turn);
void Turn_Hist_Clear(void);

/* Obsluha pohybu po historii */
int Prev_Turn (void);
int Next_Turn (void);


