/*
 *	interface.c
 *	generovani zakladniho GUI
 *	
 *	Josef Kufner <jkufner@seznam.cz>
 */

#define _REENTRANT
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "interface2.h"
#include "support.h"


  GtkWidget *main_win;
  GtkWidget *start_win;
  GtkWidget *file;

  /* Main Win */
  GtkWidget *main_win;
  GtkWidget *main_vbox;
  GtkWidget *toolbar;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *btn_new;
  GtkWidget *btn_restart;
  GtkWidget *btn_end;
  GtkWidget *btn_save;
  GtkWidget *btn_load;
  GtkWidget *btn_about;
  GtkWidget *main_hpaned;
  GtkWidget *turn_vbox;
  GtkWidget *hseparator1;
  GtkWidget *turn_toolbar;
  GtkWidget *btn_prev;
  GtkWidget *btn_next;
  GtkWidget *btn_play;
  GtkWidget *btn_stop;
  GtkWidget *turn_scrolledwindow;
  GtkWidget *turn_viewport;
  GtkWidget *turn_list;
  GtkWidget *delay_hbox;
  GtkWidget *delay_label;
  GtkObject *delay_adj;
  GtkWidget *delay;
  GtkWidget *play_scrolledwindow;
  GtkWidget *play_viewport;
  GtkWidget *pixmap;
  GtkWidget *statusbar;
  gint timer;
  int statusbar_context;

  /* Start Win */
  GtkWidget *start_win = NULL;
  GtkWidget *start_vbox;
  GtkWidget *start_notebook;
  GtkWidget *x_table;
  GtkWidget *x_local;
  GtkWidget *x_name_label;
  GtkWidget *x_name;
  GtkWidget *x_cmd_label;
  GtkWidget *x_cmd;
  GtkWidget *x_rbt;
  GtkWidget *x_net;
  GtkWidget *x_adr_label;
  GtkWidget *x_adr;
  GtkWidget *x_port_label;
  GtkObject *x_port_adj;
  GtkWidget *x_port;
  GtkWidget *x_connect;
  GtkWidget *x_wait;
  GtkWidget *x_label;
  GtkWidget *o_table;
  GtkWidget *o_local;
  GtkWidget *o_name_label;
  GtkWidget *o_name;
  GtkWidget *o_cmd_label;
  GtkWidget *o_cmd;
  GtkWidget *o_rbt;
  GtkWidget *o_net;
  GtkWidget *o_adr_label;
  GtkWidget *o_adr;
  GtkWidget *o_port_label;
  GtkObject *o_port_adj;
  GtkWidget *o_port;
  GtkWidget *o_connect;
  GtkWidget *o_wait;
  GtkWidget *o_label;
  GtkWidget *net_table;
  GtkWidget *net_adr_label;
  GtkWidget *net_port_label;
  GtkWidget *net_adr;
  GtkObject *net_port_adj;
  GtkWidget *net_port;
  GtkWidget *net_label;
  GtkWidget *game_table;
  GtkObject *row_adj;
  GtkWidget *row;
  GtkObject *col_adj;
  GtkWidget *col;
  GtkWidget *square;
  GtkWidget *begin_label;
  GtkWidget *begin_combo;
  GtkWidget *begin;
  GtkWidget *firstturn;
  GtkWidget *col_label;
  GtkWidget *row_label;
  GtkWidget *game_label;
  GtkWidget *start_hbuttonbox;
  GtkWidget *start_ok;
  GtkWidget *start_cancel;

  /* File  */
  GtkWidget *file;
  GtkWidget *file_ok;
  GtkWidget *file_cancel;
  
GtkWidget*
create_main_win (void)
{
  main_win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (main_win), "main_win", main_win);
  gtk_widget_set_usize (main_win, 470, 300);
  gtk_window_set_title (GTK_WINDOW (main_win), _("Pikvorky"));
  gtk_window_set_default_size (GTK_WINDOW (main_win), 710, 470);
  gtk_window_set_wmclass (GTK_WINDOW (main_win), "", "piskv");

  gtk_signal_connect(GTK_OBJECT(main_win), "destroy", 
		  GTK_SIGNAL_FUNC(on_exit_clicked), NULL);
  
  main_vbox = gtk_vbox_new (FALSE, 2);
  gtk_widget_ref (main_vbox);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "main_vbox", main_vbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (main_vbox);
  gtk_container_add (GTK_CONTAINER (main_win), main_vbox);

  toolbar = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (toolbar);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "toolbar", toolbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar);
  gtk_box_pack_start (GTK_BOX (main_vbox), toolbar, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (toolbar), 4);
  gtk_toolbar_set_space_size (GTK_TOOLBAR (toolbar), 15);
  gtk_toolbar_set_space_style (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_SPACE_LINE);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar), GTK_RELIEF_NONE);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (main_win, GNOME_STOCK_PIXMAP_NEW);
  btn_new = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Nov hra"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btn_new);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "btn_new", btn_new,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_new);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (main_win, GNOME_STOCK_PIXMAP_REFRESH);
  btn_restart = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Restartovat"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btn_restart);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "btn_restart", btn_restart,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_restart);
  gtk_widget_set_sensitive (btn_restart, FALSE);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (main_win, GNOME_STOCK_PIXMAP_STOP);
  btn_end = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Konec hry"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btn_end);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "btn_end", btn_end,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_end);
  gtk_widget_set_sensitive (btn_end, FALSE);

  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));

  tmp_toolbar_icon = gnome_stock_pixmap_widget (main_win, GNOME_STOCK_PIXMAP_SAVE_AS);
  btn_save = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Uloit"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btn_save);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "btn_save", btn_save,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_save);
  gtk_widget_set_sensitive (btn_save, FALSE);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (main_win, GNOME_STOCK_PIXMAP_OPEN);
  btn_load = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Otevt"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btn_load);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "btn_load", btn_load,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_load);

  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));

  tmp_toolbar_icon = gnome_stock_pixmap_widget (main_win, GNOME_STOCK_PIXMAP_ABOUT);
  btn_about = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("O programu"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btn_about);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "btn_about", btn_about,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_set_sensitive(btn_about, FALSE);
  gtk_widget_show (btn_about);

  main_hpaned = gtk_hpaned_new ();
  gtk_widget_ref (main_hpaned);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "main_hpaned", main_hpaned,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (main_hpaned);
  gtk_box_pack_start (GTK_BOX (main_vbox), main_hpaned, TRUE, TRUE, 0);
  gtk_paned_set_position (GTK_PANED (main_hpaned), 0);

  turn_vbox = gtk_vbox_new (FALSE, 2);
  gtk_widget_ref (turn_vbox);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "turn_vbox", turn_vbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_paned_pack1 (GTK_PANED (main_hpaned), turn_vbox, FALSE, FALSE);
  gtk_widget_set_usize (turn_vbox, 165, -2);
  gtk_widget_show(turn_vbox);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (turn_vbox), hseparator1, FALSE, TRUE, 0);

  turn_toolbar = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_ICONS);
  gtk_widget_ref (turn_toolbar);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "turn_toolbar", turn_toolbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (turn_toolbar);
  gtk_box_pack_start (GTK_BOX (turn_vbox), turn_toolbar, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (turn_toolbar), 2);
  gtk_widget_set_sensitive (turn_toolbar, FALSE);
  gtk_toolbar_set_space_size (GTK_TOOLBAR (turn_toolbar), 10);
  gtk_toolbar_set_space_style (GTK_TOOLBAR (turn_toolbar), GTK_TOOLBAR_SPACE_LINE);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (turn_toolbar), GTK_RELIEF_NONE);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (main_win, GNOME_STOCK_PIXMAP_UNDO);
  btn_prev = gtk_toolbar_append_element (GTK_TOOLBAR (turn_toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Pedchoz"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btn_prev);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "btn_prev", btn_prev,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_prev);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (main_win, GNOME_STOCK_PIXMAP_REDO);
  btn_next = gtk_toolbar_append_element (GTK_TOOLBAR (turn_toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Dal"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btn_next);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "btn_next", btn_next,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_next);

  gtk_toolbar_append_space (GTK_TOOLBAR (turn_toolbar));

  tmp_toolbar_icon = gnome_stock_pixmap_widget (main_win, GNOME_STOCK_PIXMAP_FORWARD);
  btn_play = gtk_toolbar_append_element (GTK_TOOLBAR (turn_toolbar),
                                GTK_TOOLBAR_CHILD_RADIOBUTTON,
                                NULL,
                                _("Pehrt"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btn_play);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "btn_play", btn_play,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_play);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (btn_play), TRUE);
  gtk_toggle_button_set_mode (GTK_TOGGLE_BUTTON (btn_play), FALSE);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (main_win, GNOME_STOCK_PIXMAP_STOP);
  btn_stop = gtk_toolbar_append_element (GTK_TOOLBAR (turn_toolbar),
                                GTK_TOOLBAR_CHILD_RADIOBUTTON,
                                btn_play,
                                _("Zastavit"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (btn_stop);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "btn_stop", btn_stop,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_stop);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (btn_stop), TRUE);
  gtk_toggle_button_set_mode (GTK_TOGGLE_BUTTON (btn_stop), FALSE);

  turn_scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (turn_scrolledwindow);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "turn_scrolledwindow", turn_scrolledwindow,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (turn_scrolledwindow);
  gtk_box_pack_start (GTK_BOX (turn_vbox), turn_scrolledwindow, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (turn_scrolledwindow), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

  turn_viewport = gtk_viewport_new (NULL, NULL);
  gtk_widget_ref (turn_viewport);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "turn_viewport", turn_viewport,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (turn_viewport);
  gtk_container_add (GTK_CONTAINER (turn_scrolledwindow), turn_viewport);

  turn_list = gtk_list_new ();
  gtk_widget_ref (turn_list);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "turn_list", turn_list,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (turn_list);
  gtk_container_add (GTK_CONTAINER (turn_viewport), turn_list);

  delay_hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (delay_hbox);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "delay_hbox", delay_hbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delay_hbox);
  gtk_box_pack_start (GTK_BOX (turn_vbox), delay_hbox, FALSE, TRUE, 0);

  delay_label = gtk_label_new (_("Delay(ms):"));
  gtk_widget_ref (delay_label);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "delay_label", delay_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delay_label);
  gtk_box_pack_start (GTK_BOX (delay_hbox), delay_label, FALSE, TRUE, 0);
  gtk_misc_set_alignment (GTK_MISC (delay_label), 1, 0.5);
  gtk_misc_set_padding (GTK_MISC (delay_label), 6, 0);

  delay_adj = gtk_adjustment_new (600, 1, 10000, 1, 10, 10);
  delay = gtk_spin_button_new (GTK_ADJUSTMENT (delay_adj), 1, 0);
  gtk_widget_ref (delay);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "delay", delay,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delay);
  gtk_box_pack_start (GTK_BOX (delay_hbox), delay, TRUE, TRUE, 0);

  play_scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (play_scrolledwindow);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "play_scrolledwindow", play_scrolledwindow,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (play_scrolledwindow);
  gtk_paned_pack2 (GTK_PANED (main_hpaned), play_scrolledwindow, TRUE, TRUE);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (play_scrolledwindow), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  play_viewport = gtk_viewport_new (NULL, NULL);
  gtk_widget_ref (play_viewport);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "play_viewport", play_viewport,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (play_viewport);
  gtk_container_add (GTK_CONTAINER (play_scrolledwindow), play_viewport);

  pixmap = create_pixmap (main_win, "about.xpm", FALSE);
  gtk_widget_ref (pixmap);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "pixmap", pixmap,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap);
  gtk_container_add (GTK_CONTAINER (play_viewport), pixmap);

  statusbar = gtk_statusbar_new ();
  gtk_widget_ref (statusbar);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "statusbar", statusbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar);
  gtk_box_pack_start (GTK_BOX (main_vbox), statusbar, FALSE, FALSE, 0);
  statusbar_context = gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar), "statusbar");


  timer = gtk_timeout_add(200, Update_Highlight, NULL);
 

  gtk_signal_connect (GTK_OBJECT (btn_new), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_new_clicked),
                      (gpointer) 1);
  gtk_signal_connect (GTK_OBJECT (btn_restart), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_new_clicked),
                      (gpointer) 0);
  gtk_signal_connect (GTK_OBJECT (btn_end), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_end_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_save), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_save_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_load), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_load_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_about), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_about_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_prev), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_step_clicked),
                      (gpointer) -1);
  gtk_signal_connect (GTK_OBJECT (btn_next), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_step_clicked),
                      (gpointer) 1);
  gtk_signal_connect (GTK_OBJECT (btn_play), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_play_clicked),
                      (gpointer) 1);
  gtk_signal_connect (GTK_OBJECT (btn_stop), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_play_clicked),
                      (gpointer) 0);
  gtk_signal_connect (GTK_OBJECT (turn_list), "select_child",
                      GTK_SIGNAL_FUNC (on_turn_list_select_child),
                      NULL);

  return main_win;
}

GtkWidget*
create_start_win (void)
{
  GList *begin_combo_items = NULL;
  GSList *o_net_group = NULL;
  GSList *o_mode_group = NULL;
  GSList *x_net_group = NULL;
  GSList *x_mode_group = NULL;

  start_win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (start_win), "start_win", start_win);
  gtk_widget_set_usize (start_win, 400, -2);
  gtk_window_set_title (GTK_WINDOW (start_win), _("Pikvorky - Start"));
  gtk_window_set_position (GTK_WINDOW (start_win), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (start_win), TRUE);
  gtk_window_set_default_size (GTK_WINDOW (start_win), 400, -1);

  start_vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (start_vbox);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "start_vbox", start_vbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (start_vbox);
  gtk_container_add (GTK_CONTAINER (start_win), start_vbox);

  start_notebook = gtk_notebook_new ();
  gtk_widget_ref (start_notebook);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "start_notebook", start_notebook,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (start_notebook);
  gtk_box_pack_start (GTK_BOX (start_vbox), start_notebook, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (start_notebook), 4);

  x_table = gtk_table_new (9, 2, FALSE);
  gtk_widget_ref (x_table);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "x_table", x_table,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_table);
  gtk_container_add (GTK_CONTAINER (start_notebook), x_table);
  gtk_container_set_border_width (GTK_CONTAINER (x_table), 10);
  gtk_table_set_row_spacings (GTK_TABLE (x_table), 2);
  gtk_table_set_col_spacings (GTK_TABLE (x_table), 6);

  x_local = gtk_radio_button_new_with_label (x_mode_group, _("Mstn:"));
  x_mode_group = gtk_radio_button_group (GTK_RADIO_BUTTON (x_local));
  gtk_widget_ref (x_local);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "x_local", x_local,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_local);
  gtk_table_attach (GTK_TABLE (x_table), x_local, 0, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (x_local), TRUE);

  x_name_label = gtk_label_new (_("Jmno:"));
  gtk_widget_ref (x_name_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "x_name_label", x_name_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_name_label);
  gtk_table_attach (GTK_TABLE (x_table), x_name_label, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (x_name_label), 1, 0.5);

  x_name = gtk_entry_new ();
  gtk_widget_ref (x_name);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "x_name", x_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_name);
  gtk_table_attach (GTK_TABLE (x_table), x_name, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  x_cmd_label = gtk_label_new (_("Pkaz:"));
  gtk_widget_ref (x_cmd_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "x_cmd_label", x_cmd_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_cmd_label);
  gtk_table_attach (GTK_TABLE (x_table), x_cmd_label, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (x_cmd_label), 0, 0.5);

  x_cmd = gtk_entry_new ();
  gtk_widget_ref (x_cmd);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "x_cmd", x_cmd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_cmd);
  gtk_table_attach (GTK_TABLE (x_table), x_cmd, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_text (GTK_ENTRY (x_cmd), _("/usr/local/bin/piskv-rbt"));

  x_rbt = gtk_check_button_new_with_label (_("Hraje robot"));
  gtk_widget_ref (x_rbt);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "x_rbt", x_rbt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_rbt);
  gtk_table_attach (GTK_TABLE (x_table), x_rbt, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (x_rbt), TRUE);

  x_net = gtk_radio_button_new_with_label (x_mode_group, _("Vzdlen:"));
  x_mode_group = gtk_radio_button_group (GTK_RADIO_BUTTON (x_net));
  gtk_widget_ref (x_net);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "x_net", x_net,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_net);
  gtk_table_attach (GTK_TABLE (x_table), x_net, 0, 2, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  x_adr_label = gtk_label_new (_("Adresa:"));
  gtk_widget_ref (x_adr_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "x_adr_label", x_adr_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_adr_label);
  gtk_table_attach (GTK_TABLE (x_table), x_adr_label, 0, 1, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive (x_adr_label, FALSE);
  gtk_misc_set_alignment (GTK_MISC (x_adr_label), 1, 0.5);

  x_adr = gtk_entry_new ();
  gtk_widget_ref (x_adr);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "x_adr", x_adr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_adr);
  gtk_table_attach (GTK_TABLE (x_table), x_adr, 1, 2, 5, 6,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive (x_adr, FALSE);
  gtk_entry_set_text (GTK_ENTRY (x_adr), _("127.0.0.1"));

  x_port_label = gtk_label_new (_("Port:"));
  gtk_widget_ref (x_port_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "x_port_label", x_port_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_port_label);
  gtk_table_attach (GTK_TABLE (x_table), x_port_label, 0, 1, 6, 7,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive (x_port_label, FALSE);
  gtk_misc_set_alignment (GTK_MISC (x_port_label), 1, 0.5);

  x_port_adj = gtk_adjustment_new (5544, 0, 65535, 1, 10, 10);
  x_port = gtk_spin_button_new (GTK_ADJUSTMENT (x_port_adj), 1, 0);
  gtk_widget_ref (x_port);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "x_port", x_port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_port);
  gtk_table_attach (GTK_TABLE (x_table), x_port, 1, 2, 6, 7,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive (x_port, FALSE);

  x_connect = gtk_radio_button_new_with_label (x_net_group, _("Pipojit se"));
  x_net_group = gtk_radio_button_group (GTK_RADIO_BUTTON (x_connect));
  gtk_widget_ref (x_connect);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "x_connect", x_connect,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_connect);
  gtk_table_attach (GTK_TABLE (x_table), x_connect, 1, 2, 7, 8,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive (x_connect, FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (x_connect), TRUE);

  x_wait = gtk_radio_button_new_with_label (x_net_group, _("Pokat"));
  x_net_group = gtk_radio_button_group (GTK_RADIO_BUTTON (x_wait));
  gtk_widget_ref (x_wait);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "x_wait", x_wait,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_wait);
  gtk_table_attach (GTK_TABLE (x_table), x_wait, 1, 2, 8, 9,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive (x_wait, FALSE);

  x_label = gtk_label_new (_("Hr X"));
  gtk_widget_ref (x_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "x_label", x_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (start_notebook), 
		  gtk_notebook_get_nth_page (GTK_NOTEBOOK (start_notebook), 0), x_label);

  o_table = gtk_table_new (9, 2, FALSE);
  gtk_widget_ref (o_table);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "o_table", o_table,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (o_table);
  gtk_container_add (GTK_CONTAINER (start_notebook), o_table);
  gtk_container_set_border_width (GTK_CONTAINER (o_table), 10);
  gtk_table_set_row_spacings (GTK_TABLE (o_table), 2);
  gtk_table_set_col_spacings (GTK_TABLE (o_table), 6);

  o_local = gtk_radio_button_new_with_label (o_mode_group, _("Mstn:"));
  o_mode_group = gtk_radio_button_group (GTK_RADIO_BUTTON (o_local));
  gtk_widget_ref (o_local);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "o_local", o_local,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (o_local);
  gtk_table_attach (GTK_TABLE (o_table), o_local, 0, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (o_local), TRUE);

  o_name_label = gtk_label_new (_("Jmno:"));
  gtk_widget_ref (o_name_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "o_name_label", o_name_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (o_name_label);
  gtk_table_attach (GTK_TABLE (o_table), o_name_label, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (o_name_label), 1, 0.5);

  o_name = gtk_entry_new ();
  gtk_widget_ref (o_name);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "o_name", o_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (o_name);
  gtk_table_attach (GTK_TABLE (o_table), o_name, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  o_cmd_label = gtk_label_new (_("Pkaz:"));
  gtk_widget_ref (o_cmd_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "o_cmd_label", o_cmd_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (o_cmd_label);
  gtk_table_attach (GTK_TABLE (o_table), o_cmd_label, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (o_cmd_label), 0, 0.5);

  o_cmd = gtk_entry_new ();
  gtk_widget_ref (o_cmd);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "o_cmd", o_cmd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (o_cmd);
  gtk_table_attach (GTK_TABLE (o_table), o_cmd, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_text (GTK_ENTRY (o_cmd), _("/usr/local/bin/piskv-rbt"));

  o_rbt = gtk_check_button_new_with_label (_("Hraje robot"));
  gtk_widget_ref (o_rbt);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "o_rbt", o_rbt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (o_rbt);
  gtk_table_attach (GTK_TABLE (o_table), o_rbt, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (o_rbt), TRUE);

  o_net = gtk_radio_button_new_with_label (o_mode_group, _("Vzdlen:"));
  o_mode_group = gtk_radio_button_group (GTK_RADIO_BUTTON (o_net));
  gtk_widget_ref (o_net);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "o_net", o_net,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (o_net);
  gtk_table_attach (GTK_TABLE (o_table), o_net, 0, 2, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  o_adr_label = gtk_label_new (_("Adresa:"));
  gtk_widget_ref (o_adr_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "o_adr_label", o_adr_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (o_adr_label);
  gtk_table_attach (GTK_TABLE (o_table), o_adr_label, 0, 1, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive (o_adr_label, FALSE);
  gtk_misc_set_alignment (GTK_MISC (o_adr_label), 1, 0.5);

  o_adr = gtk_entry_new ();
  gtk_widget_ref (o_adr);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "o_adr", o_adr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (o_adr);
  gtk_table_attach (GTK_TABLE (o_table), o_adr, 1, 2, 5, 6,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive (o_adr, FALSE);
  gtk_entry_set_text (GTK_ENTRY (o_adr), _("127.0.0.1"));

  o_port_label = gtk_label_new (_("Port:"));
  gtk_widget_ref (o_port_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "o_port_label", o_port_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (o_port_label);
  gtk_table_attach (GTK_TABLE (o_table), o_port_label, 0, 1, 6, 7,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive (o_port_label, FALSE);
  gtk_misc_set_alignment (GTK_MISC (o_port_label), 1, 0.5);

  o_port_adj = gtk_adjustment_new (5544, 0, 65535, 1, 10, 10);
  o_port = gtk_spin_button_new (GTK_ADJUSTMENT (o_port_adj), 1, 0);
  gtk_widget_ref (o_port);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "o_port", o_port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (o_port);
  gtk_table_attach (GTK_TABLE (o_table), o_port, 1, 2, 6, 7,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive (o_port, FALSE);

  o_connect = gtk_radio_button_new_with_label (o_net_group, _("Pipojit se"));
  o_net_group = gtk_radio_button_group (GTK_RADIO_BUTTON (o_connect));
  gtk_widget_ref (o_connect);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "o_connect", o_connect,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (o_connect);
  gtk_table_attach (GTK_TABLE (o_table), o_connect, 1, 2, 7, 8,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive (o_connect, FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (o_connect), TRUE);

  o_wait = gtk_radio_button_new_with_label (o_net_group, _("Pokat"));
  o_net_group = gtk_radio_button_group (GTK_RADIO_BUTTON (o_wait));
  gtk_widget_ref (o_wait);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "o_wait", o_wait,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (o_wait);
  gtk_table_attach (GTK_TABLE (o_table), o_wait, 1, 2, 8, 9,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive (o_wait, FALSE);

  o_label = gtk_label_new (_("Hr O"));
  gtk_widget_ref (o_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "o_label", o_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (o_label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (start_notebook), 
		  gtk_notebook_get_nth_page (GTK_NOTEBOOK (start_notebook), 1), o_label);

  net_table = gtk_table_new (2, 2, FALSE);
  gtk_widget_ref (net_table);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "net_table", net_table,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (net_table);
  gtk_container_add (GTK_CONTAINER (start_notebook), net_table);
  gtk_container_set_border_width (GTK_CONTAINER (net_table), 10);
  gtk_table_set_row_spacings (GTK_TABLE (net_table), 2);
  gtk_table_set_col_spacings (GTK_TABLE (net_table), 6);

  net_adr_label = gtk_label_new (_("Zdej Adresa:"));
  gtk_widget_ref (net_adr_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "net_adr_label", net_adr_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (net_adr_label);
  gtk_table_attach (GTK_TABLE (net_table), net_adr_label, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (net_adr_label), 0, 0.5);

  net_port_label = gtk_label_new (_("Zdej Port:"));
  gtk_widget_ref (net_port_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "net_port_label", net_port_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (net_port_label);
  gtk_table_attach (GTK_TABLE (net_table), net_port_label, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (net_port_label), 0, 0.5);

  net_adr = gtk_entry_new ();
  gtk_widget_ref (net_adr);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "net_adr", net_adr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (net_adr);
  gtk_table_attach (GTK_TABLE (net_table), net_adr, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_text (GTK_ENTRY (net_adr), _("127.0.0.1"));

  net_port_adj = gtk_adjustment_new (5544, 0, 65535, 1, 10, 10);
  net_port = gtk_spin_button_new (GTK_ADJUSTMENT (net_port_adj), 1, 0);
  gtk_widget_ref (net_port);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "net_port", net_port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (net_port);
  gtk_table_attach (GTK_TABLE (net_table), net_port, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  net_label = gtk_label_new (_("Konfigurace st"));
  gtk_widget_ref (net_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "net_label", net_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (net_label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (start_notebook), 
		  gtk_notebook_get_nth_page (GTK_NOTEBOOK (start_notebook), 2), net_label);

  game_table = gtk_table_new (8, 2, FALSE);
  gtk_widget_ref (game_table);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "game_table", game_table,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (game_table);
  gtk_container_add (GTK_CONTAINER (start_notebook), game_table);
  gtk_container_set_border_width (GTK_CONTAINER (game_table), 10);
  gtk_table_set_row_spacings (GTK_TABLE (game_table), 2);
  gtk_table_set_col_spacings (GTK_TABLE (game_table), 6);

  row_adj = gtk_adjustment_new (25, 6, 50, 1, 10, 10);
  row = gtk_spin_button_new (GTK_ADJUSTMENT (row_adj), 1, 0);
  gtk_widget_ref (row);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "row", row,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (row);
  gtk_table_attach (GTK_TABLE (game_table), row, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  col_adj = gtk_adjustment_new (25, 6, 50, 1, 10, 10);
  col = gtk_spin_button_new (GTK_ADJUSTMENT (col_adj), 1, 0);
  gtk_widget_ref (col);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "col", col,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (col);
  gtk_table_attach (GTK_TABLE (game_table), col, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive(col, FALSE);

  square = gtk_check_button_new_with_label (_("tvercov hrac plocha"));
  gtk_widget_ref (square);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "square", square,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (square);
  gtk_table_attach (GTK_TABLE (game_table), square, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive (square, FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (square), TRUE);

  begin_label = gtk_label_new (_("Zan:"));
  gtk_widget_ref (begin_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "begin_label", begin_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (begin_label);
  gtk_table_attach (GTK_TABLE (game_table), begin_label, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (begin_label), 1, 0.5);

  begin_combo = gtk_combo_new ();
  gtk_widget_ref (begin_combo);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "begin_combo", begin_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (begin_combo);
  gtk_table_attach (GTK_TABLE (game_table), begin_combo, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_combo_set_value_in_list (GTK_COMBO (begin_combo), TRUE, TRUE);
  gtk_combo_set_case_sensitive (GTK_COMBO (begin_combo), TRUE);
  begin_combo_items = g_list_append (begin_combo_items, (gpointer) _("X"));
  begin_combo_items = g_list_append (begin_combo_items, (gpointer) _("O"));
  gtk_combo_set_popdown_strings (GTK_COMBO (begin_combo), begin_combo_items);
  g_list_free (begin_combo_items);

  begin = GTK_COMBO (begin_combo)->entry;
  gtk_widget_ref (begin);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "begin", begin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (begin);
  gtk_entry_set_editable (GTK_ENTRY (begin), FALSE);
  gtk_entry_set_text (GTK_ENTRY (begin), _("X"));

  firstturn = gtk_check_button_new_with_label (_("Generovat prvn tah"));
  gtk_widget_ref (firstturn);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "firstturn", firstturn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (firstturn);
  gtk_table_attach (GTK_TABLE (game_table), firstturn, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_sensitive (firstturn, FALSE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (firstturn), FALSE);

  col_label = gtk_label_new (_("Poet sloupc hrac plochy:"));
  gtk_widget_ref (col_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "col_label", col_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (col_label);
  gtk_table_attach (GTK_TABLE (game_table), col_label, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (col_label), 1, 0.5);
  gtk_widget_set_sensitive(col_label, FALSE);

  row_label = gtk_label_new (_("Poet dek hrac plochy:"));
  gtk_widget_ref (row_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "row_label", row_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (row_label);
  gtk_table_attach (GTK_TABLE (game_table), row_label, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (row_label), 1, 0.5);

  game_label = gtk_label_new (_("Nastaven hry:"));
  gtk_widget_ref (game_label);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "game_label", game_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (game_label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (start_notebook), 
		  gtk_notebook_get_nth_page (GTK_NOTEBOOK (start_notebook), 3), game_label);

  start_hbuttonbox = gtk_hbutton_box_new ();
  gtk_widget_ref (start_hbuttonbox);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "start_hbuttonbox", start_hbuttonbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (start_hbuttonbox);
  gtk_box_pack_start (GTK_BOX (start_vbox), start_hbuttonbox, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (start_hbuttonbox), 10);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (start_hbuttonbox), GTK_BUTTONBOX_END);

  start_ok = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (start_ok);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "start_ok", start_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (start_ok);
  gtk_container_add (GTK_CONTAINER (start_hbuttonbox), start_ok);
  GTK_WIDGET_SET_FLAGS (start_ok, GTK_CAN_DEFAULT);

  start_cancel = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (start_cancel);
  gtk_object_set_data_full (GTK_OBJECT (start_win), "start_cancel", start_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (start_cancel);
  gtk_container_add (GTK_CONTAINER (start_hbuttonbox), start_cancel);
  GTK_WIDGET_SET_FLAGS (start_cancel, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (start_win), "destroy",
		      GTK_SIGNAL_FUNC (gtk_widget_hide),
		      NULL);
  gtk_signal_connect (GTK_OBJECT (x_local), "toggled",
                      GTK_SIGNAL_FUNC (on_x_toggled),
                      (gpointer) 0);
  gtk_signal_connect (GTK_OBJECT (x_net), "toggled",
                      GTK_SIGNAL_FUNC (on_x_toggled),
                      (gpointer) 1);
  gtk_signal_connect (GTK_OBJECT (x_rbt), "toggled",
                      GTK_SIGNAL_FUNC (on_x_rbt_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (x_connect), "toggled",
                      GTK_SIGNAL_FUNC (on_x_connect_toggled),
                      (gpointer) 1);
  gtk_signal_connect (GTK_OBJECT (x_wait), "toggled",
                      GTK_SIGNAL_FUNC (on_x_connect_toggled),
                      (gpointer) 0);
  gtk_signal_connect (GTK_OBJECT (o_local), "toggled",
                      GTK_SIGNAL_FUNC (on_o_toggled),
                      (gpointer) 0);
  gtk_signal_connect (GTK_OBJECT (o_net), "toggled",
                      GTK_SIGNAL_FUNC (on_o_toggled),
                      (gpointer) 1);
  gtk_signal_connect (GTK_OBJECT (o_rbt), "toggled",
                      GTK_SIGNAL_FUNC (on_o_rbt_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (o_connect), "toggled",
                      GTK_SIGNAL_FUNC (on_o_connect_toggled),
                      (gpointer) 1);
  gtk_signal_connect (GTK_OBJECT (o_wait), "toggled",
                      GTK_SIGNAL_FUNC (on_o_connect_toggled),
                      (gpointer) 0);
  gtk_signal_connect (GTK_OBJECT (firstturn), "toggled",
                      GTK_SIGNAL_FUNC (on_firstturn_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (start_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_start_clicked),
                      (gpointer) 1);	
  gtk_signal_connect (GTK_OBJECT (start_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_start_clicked),
                      (gpointer) 0);

  gtk_widget_grab_default (start_ok);
  return start_win;
}

GtkWidget*
create_file (void)
{

  file = gtk_file_selection_new (_("Pikvorky - Vbr souboru"));
  gtk_object_set_data (GTK_OBJECT (file), "file", file);
  gtk_container_set_border_width (GTK_CONTAINER (file), 10);
  gtk_window_set_position (GTK_WINDOW (file), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (file), TRUE);

  file_ok = GTK_FILE_SELECTION (file)->ok_button;
  gtk_object_set_data (GTK_OBJECT (file), "file_ok", file_ok);
  gtk_widget_show (file_ok);
  GTK_WIDGET_SET_FLAGS (file_ok, GTK_CAN_DEFAULT);

  file_cancel = GTK_FILE_SELECTION (file)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (file), "file_cancel", file_cancel);
  gtk_widget_show (file_cancel);
  GTK_WIDGET_SET_FLAGS (file_cancel, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (file_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_file_btn_clicked),
                      (gpointer) 1);
  gtk_signal_connect (GTK_OBJECT (file_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_file_btn_clicked),
                      (gpointer) 0);

  return file;
}

