/*
 * 	interface2.c
 * 	Doplnkove funkce ke GUI
 *
 * 	Josef Kufner <jkufner@seznam.cz>
 *
 */

#define _REENTRANT

#include <gnome.h>

#include "support.h"
#include "interface.h"
#include "interface2.h"
#include "callbacks.h"
#include "game.h"


/* Widgety - Hraci plocha */
  GtkWidget *play_view_table;
  GtkWidget *play_table = NULL;
  GtkWidget **btn_game;
  GtkWidget **btn_game_label;
  GtkWidget **play_htitle_label;
  GtkWidget **play_vtitle_label;

gint play_timer = 0;

/* Promenne pro 'highlight' policek */
int highlight_turn[HIGHLIGHT_MAX];
int highlight_pos;
int highlight_state = 0;

  
void refresh_btns (void) {
	gtk_widget_set_sensitive(btn_new, !is_game_now);
	gtk_widget_set_sensitive(btn_restart, !is_game_now);
	gtk_widget_set_sensitive(btn_end, is_game_now);
	
	gtk_widget_set_sensitive(btn_load, !is_game_now);
	gtk_widget_set_sensitive(btn_save, !is_game_now);
	
	gtk_widget_set_sensitive(btn_about, FALSE);

	gtk_widget_set_sensitive(turn_toolbar, !is_game_now);
}

void Show_Turn(int turn, int player) {
 char str[3];
	
	sprintf(str, "%c", PLAYER_SYMBOL(player));
	if (highlight_pos < HIGHLIGHT_MAX) {
		gtk_label_set_text(GTK_LABEL(btn_game_label[turn]), str);
	}
	gtk_widget_draw(btn_game_label[turn], NULL);
}

void Remove_Highlight(void) {
	highlight_pos = 0;
}

void Highlight_Turn (int player, int turn) {
	if (highlight_pos < HIGHLIGHT_MAX) {
		highlight_turn[highlight_pos] = turn;
		highlight_pos++;
	}
}

void Message (char *msg) {
	gtk_statusbar_pop(GTK_STATUSBAR(statusbar), statusbar_context);
	gtk_statusbar_push(GTK_STATUSBAR(statusbar), statusbar_context, msg);
}

void Create_Play_Area(void) {
 int row, col;
 char str[32];
	
	gtk_widget_destroy(pixmap);

	/* Alokace pameti */
	btn_game = (GtkWidget **) malloc (game_cfg.row * game_cfg.col * sizeof(GtkWidget*));
	btn_game_label = (GtkWidget **) malloc (game_cfg.row * game_cfg.col * sizeof(GtkWidget*));
	play_htitle_label = (GtkWidget **) malloc (game_cfg.row * sizeof(GtkWidget*));
	play_vtitle_label = (GtkWidget **) malloc (game_cfg.col * sizeof(GtkWidget*));

	/* Vycisteni zvyraznovani */
	highlight_pos = 0;
	
	/* Tvorba hraci plochy */
	play_view_table = gtk_table_new (2, 2, FALSE);
	gtk_widget_ref (play_view_table);
	gtk_object_set_data_full (GTK_OBJECT (main_win), "play_view_table", play_view_table,
			(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (play_view_table);
	gtk_container_add (GTK_CONTAINER (play_viewport), play_view_table);

	play_table = gtk_table_new (5, 4, FALSE);
	gtk_widget_ref (play_table);
	gtk_object_set_data_full (GTK_OBJECT (main_win), "play_table", play_table,
			(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (play_table);
	gtk_table_attach (GTK_TABLE (play_view_table), play_table, 0, 1, 0, 1,
			(GtkAttachOptions) (GTK_FILL),
			(GtkAttachOptions) (GTK_FILL), 0, 0);

	for (row = 0; row < game_cfg.row; row ++) {
		for (col = 0; col < game_cfg.col; col++) {
			btn_game[row * game_cfg.col + col] = gtk_button_new ();
			gtk_widget_ref (btn_game[row * game_cfg.col + col]);
			gtk_object_set_data_full (GTK_OBJECT (main_win), "btn_game", btn_game[row * game_cfg.col + col],
					(GtkDestroyNotify) gtk_widget_unref);
			gtk_widget_show (btn_game[row * game_cfg.col + col]);
			gtk_table_attach (GTK_TABLE (play_table), btn_game[row * game_cfg.col + col], 
					1 + col, 2 + col, 1 + row, 2 + row,
					(GtkAttachOptions) (GTK_FILL),
					(GtkAttachOptions) (0), 0, 0);
			gtk_widget_set_usize (btn_game[row * game_cfg.col + col], 22, 22);
			
			btn_game_label[row * game_cfg.col + col] = gtk_label_new (_(" "));
			gtk_widget_ref (btn_game_label[row * game_cfg.col + col]);
			gtk_object_set_data_full (GTK_OBJECT (main_win), "btn_game_label", 
					btn_game_label[row * game_cfg.col + col],
					(GtkDestroyNotify) gtk_widget_unref);
			gtk_widget_show (btn_game_label[row * game_cfg.col + col]);
			gtk_container_add (GTK_CONTAINER (btn_game[row * game_cfg.col + col]), 
					btn_game_label[row * game_cfg.col + col]);
			
			gtk_signal_connect (GTK_OBJECT (btn_game[row * game_cfg.col + col]), "clicked", 
					GTK_SIGNAL_FUNC (on_btn_game_clicked),
					(gpointer) (row * game_cfg.col + col));
		}
	}

	for (col = 0; col < game_cfg.col; col++) {
		sprintf(str, "%d", col);
		play_htitle_label[col] = gtk_label_new (str);
		gtk_widget_ref (play_htitle_label[col]);
		gtk_object_set_data_full (GTK_OBJECT (main_win), "play_htitle_label", play_htitle_label[col],
				(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_show (play_htitle_label[col]);
		gtk_table_attach (GTK_TABLE (play_table), play_htitle_label[col], 1 + col, 2 + col, 0, 1,
				(GtkAttachOptions) (GTK_FILL),
				(GtkAttachOptions) (GTK_FILL), 0, 0);
		gtk_widget_set_usize (play_htitle_label[col], -2, 22);
	}

	for (row = 0; row < game_cfg.row; row++) {
		sprintf(str, "%d", row);
		play_vtitle_label[row] = gtk_label_new (str);
		gtk_widget_ref (play_vtitle_label[row]);
		gtk_object_set_data_full (GTK_OBJECT (main_win), "play_vtitle_label", play_vtitle_label[row],
                            (GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_show (play_vtitle_label[row]);
		gtk_table_attach (GTK_TABLE (play_table), play_vtitle_label[row], 0, 1, 1 + row, 2 + row,
				(GtkAttachOptions) (GTK_FILL),
				(GtkAttachOptions) (GTK_FILL), 0, 0);
		gtk_widget_set_usize (play_vtitle_label[row], 22, -2);
		gtk_misc_set_alignment (GTK_MISC (play_vtitle_label[row]), 1, 0.5);
		gtk_misc_set_padding (GTK_MISC (play_vtitle_label[row]), 5, 0);
	}
}

void Destroy_Play_Area(void) {
 int row, col;
 
 	if (! play_table)
		return;

 	/* Likvidace plochy */
	for (row = 0; row < game_cfg.row; row++)
		gtk_widget_destroy(play_vtitle_label[row]);
	
	for (col = 0; col < game_cfg.col; col++)
		gtk_widget_destroy(play_htitle_label[col]);

	for (row = 0; row < game_cfg.row; row++) {
		for (col = 0; col < game_cfg.col; col++) {
			gtk_widget_destroy(btn_game_label[row * game_cfg.col + col]);
			gtk_widget_destroy(btn_game[row * game_cfg.col + col]);
		}
	}
	
	gtk_widget_destroy(play_table);
	play_table = NULL;
	gtk_container_remove (GTK_CONTAINER (play_viewport), play_view_table);
	gtk_widget_destroy(play_view_table);
	
	/* Uvolneni pameti */
	free(btn_game);
	free(play_htitle_label);
	free(play_vtitle_label);
}


void Hist_List_Update(void) {
 static GList *list = NULL;
 int player, turn, ret, n;
 char str[256];
 GtkWidget *item = NULL;
 	
	/* Likvidace starych polozek v okne */
 	if (list) {
		gtk_list_remove_items(GTK_LIST(turn_list), list);
		list = NULL;
	}
 	
 	/* Nastaveni pozice v seznamu na zacatek a prvni cteni */ 
	ret = Turn_Hist_Get_Item(TH_START, &player, &turn);
	n = 1;
 	/* Cteni ostatnich polozek */
	while (ret == 0) {
		/* Zobrazeni polozky */
		sprintf(str, "%d.) %c: r = %d, c = %d;", n++, PLAYER_SYMBOL(player), 
				turn / game_cfg.col, turn % game_cfg.row);
	
	 	item = gtk_list_item_new_with_label(str);
		list = g_list_append(list, item);
		gtk_object_set_data(GTK_OBJECT(item), "list_item_data", "new item with label");
		gtk_widget_show(item);
		
		/* Cteni dalsi polozky seznamu */
		ret = Turn_Hist_Get_Item(TH_NEXT, &player, &turn);
	}
	gtk_list_append_items(GTK_LIST(turn_list), list);
}


void Hist_List_Move (int kam) {
 static int pos = 0;
	
	switch (kam) {
		case HL_NEXT:		/* Dalsi polozka */
			pos++;
			break;
		case HL_PREV:		/* Predchozi polozka */
			if (pos > 0)
				pos--;
			break;
		case HL_BEGIN:		/* Na zacatek */
			pos = 0;
			break;
		case HL_END:		/* Na konec */
			/* ? */
			break;
		default:
			break;
	}

	gtk_list_select_item(GTK_LIST(turn_list), pos);
}

void Start_Win_Net_Update (void) {

	gtk_widget_set_sensitive (x_adr_label, GTK_TOGGLE_BUTTON(x_net)->active);
	gtk_widget_set_sensitive (x_adr, GTK_TOGGLE_BUTTON(x_net)->active);
	gtk_widget_set_sensitive (x_port_label, GTK_TOGGLE_BUTTON(x_net)->active);
	gtk_widget_set_sensitive (x_port, GTK_TOGGLE_BUTTON(x_net)->active);
	gtk_widget_set_sensitive (x_connect, GTK_TOGGLE_BUTTON(x_net)->active);
	gtk_widget_set_sensitive (x_wait, GTK_TOGGLE_BUTTON(x_net)->active);

	gtk_widget_set_sensitive (o_adr_label, GTK_TOGGLE_BUTTON(o_net)->active);
	gtk_widget_set_sensitive (o_adr, GTK_TOGGLE_BUTTON(o_net)->active);
	gtk_widget_set_sensitive (o_port_label, GTK_TOGGLE_BUTTON(o_net)->active);
	gtk_widget_set_sensitive (o_port, GTK_TOGGLE_BUTTON(o_net)->active);
	gtk_widget_set_sensitive (o_connect, GTK_TOGGLE_BUTTON(o_net)->active);
	gtk_widget_set_sensitive (o_wait, GTK_TOGGLE_BUTTON(o_net)->active);

	gtk_widget_set_sensitive (x_name_label, !GTK_TOGGLE_BUTTON(x_net)->active);
	gtk_widget_set_sensitive (x_name, !GTK_TOGGLE_BUTTON(x_net)->active);
	gtk_widget_set_sensitive (x_cmd_label, !GTK_TOGGLE_BUTTON(x_net)->active);
	gtk_widget_set_sensitive (x_rbt, !GTK_TOGGLE_BUTTON(x_net)->active);
	gtk_widget_set_sensitive (x_cmd, GTK_TOGGLE_BUTTON(x_rbt)->active && !GTK_TOGGLE_BUTTON(x_net)->active);
	gtk_widget_set_sensitive (x_cmd_label, GTK_TOGGLE_BUTTON(x_rbt)->active && !GTK_TOGGLE_BUTTON(x_net)->active);

	gtk_widget_set_sensitive (o_name_label, !GTK_TOGGLE_BUTTON(o_net)->active);
	gtk_widget_set_sensitive (o_name, !GTK_TOGGLE_BUTTON(o_net)->active);
	gtk_widget_set_sensitive (o_cmd_label, !GTK_TOGGLE_BUTTON(o_net)->active);
	gtk_widget_set_sensitive (o_rbt, !GTK_TOGGLE_BUTTON(o_net)->active);
	gtk_widget_set_sensitive (o_cmd, GTK_TOGGLE_BUTTON(o_rbt)->active && !GTK_TOGGLE_BUTTON(o_net)->active);
	gtk_widget_set_sensitive (o_cmd_label, GTK_TOGGLE_BUTTON(o_rbt)->active && !GTK_TOGGLE_BUTTON(o_net)->active);
}

